%define	name	libsigc++1.0
%define	version	1.0.4
%define	release	%mkrel 12
%define	api_version	1.0
%define	lib_major	0
%define	short_name	sigc++%{lib_major}
%define	lib_name_orig	libsigc++
%define	lib_name	%mklibname sigc++ %{api_version} %{lib_major}

Name:		%{name}
Summary:	The Typesafe Signal Framework for C++
Version:	%{version}
Release:	%{release}
License:	LGPL
Source0:	ftp://download.sourceforge.net/pub/sourceforge/libsigc/%{lib_name_orig}-%{version}.tar.bz2
Patch1:		libsigc++-1.0.4-fix-makefile.patch.bz2
Patch2:		libsigc++-1.0.4-fix-underquoted-calls.patch.bz2
Url:		http://libsigc.sourceforge.net/
Group:		System/Libraries
#BuildRequires: /usr/bin/perl gcc-c++
BuildRequires:	automake1.4
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Callback system for use in widget libraries, abstract interfaces, and
general programming.

This library implements a full callback system for use in widget
libraries, abstract interfaces, and general programming. Originally part
of the Gtk-- widget set, %{name} is now a separate library to provide for
more general use. It is the most complete library of its kind with the
ablity to connect an abstract callback to a class method, function, or
function object. It contains adaptor classes for connection of dissimilar
callbacks and has an ease of use unmatched by other C++ callback
libraries.

Package gtkmm, which is a c++ binding to the famous gtk+ library, uses
%{name}.

%package -n	%{lib_name}
Summary:	Main library for %{name}
Group:		System/Libraries

%description -n	%{lib_name}
This package contains the library needed to run programs dynamically
linked with %{name}.

%package -n	%{lib_name}-devel
Summary:	Headers for developing programs that will use %{name}
Group:		Development/C++
Requires:	%{lib_name} = %{version}
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{lib_name}-devel
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%package -n	%{lib_name}-examples
Summary:	Examples and tests for the Typesafe Signal Framework for C++ 
Group:		Development/C++
Requires:	%{lib_name}-devel = %{version}

%description -n	%{lib_name}-examples
This package contains source code of example and test programs for
%{name}.

%prep
%setup -q -n %{lib_name_orig}-%{version}
%patch1 -p0
%patch2 -p1 -b .underquoted
perl -pi -e 's|\${prefix}|%{_prefix}|' README
perl -pi -e 's|PREFIX|%{_prefix}|' doc/FAQ

%build
automake-1.4
# (gc) temp removed. really useful?
#%ifarch alpha
#  ARCH_FLAGS="--host=alpha-redhat-linux"
#%endif

%configure
%make

%check
# (gb) all tests must pass
make check

%install
rm -rf $RPM_BUILD_ROOT
#install -d -m 755 $RPM_BUILD_ROOT%{prefix}/{{include,lib}/%{short_name}}
#make install INSTALL="%(which install) -p" prefix=$RPM_BUILD_ROOT%{prefix}
%makeinstall

mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{short_name}
cp -a examples tests $RPM_BUILD_ROOT%{_libdir}/%{short_name}
find $RPM_BUILD_ROOT%{_libdir}/%{short_name} -type f|xargs file|fgrep relocatable|cut -d: -f1|xargs rm -f
find $RPM_BUILD_ROOT%{_libdir}/%{short_name} -type f|xargs file|fgrep executable|cut -d: -f1|xargs rm -f
find $RPM_BUILD_ROOT%{_libdir}/%{short_name} -type f|xargs file|fgrep 'shell script'|cut -d: -f1|xargs rm -f
find $RPM_BUILD_ROOT%{_libdir}/%{short_name} -type d -name .libs|xargs rm -rf

for i in $RPM_BUILD_ROOT%{_libdir}/%{short_name}/examples/Makefile $RPM_BUILD_ROOT%{_libdir}/%{short_name}/tests/*/Makefile; do
	rm -f $i.*
	cp -p scripts/tests.Makefile $i
done
for i in $RPM_BUILD_ROOT%{_libdir}/%{short_name}/tests/Makefile; do
	rm -f $i.*
	cp -p scripts/examples.Makefile $i
done

# multiarch policy
%multiarch_binaries $RPM_BUILD_ROOT%{_bindir}/sigc-config

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files -n %{lib_name}
%defattr(-,root,root)
%doc AUTHORS COPYING.LIB README
%attr(755,root,root) %{_libdir}/lib*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc ChangeLog TODO IDEAS doc/*
%{_bindir}/*
%{_includedir}/*
%{_datadir}/aclocal/*
%{_libdir}/lib*.so
%{_libdir}/*.a
%{_libdir}/*.la

%files -n %{lib_name}-examples
%defattr(-,root,root)
%doc COPYING
%{_libdir}/%{short_name}/examples
%{_libdir}/%{short_name}/tests

%changelog
* Sun Nov 05 2006 Texstar <texstar@houston.rr.com> 1.0.4-12pclos2007
- Build for PCLinuxOS 2007

